/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package general;

import java.io.*;
import java.util.Random;
import ui.CertificateChooser;

/**
 *
 * @author 96011339
 */
public class SuperIntegrator
{
    private static String _newLine = System.getProperty("line.separator");
    private String _configPath;
    private String _tempPath;
    private String _xmlFile;
    private Integrator _integrator;
    private Random _random = new Random();
    public String _erori = null;

    //configPath si chooser este necesar numai daca se apeleaza signPdf;
    //  altfel null
    //tempPath necesar numai daca se foloseste setul de functii avand 
    //  continutul fisierului de prelucrat in buffer, ca parametru.
    //signatureDefinition este necesar numai daca se apeleaza signPdf si
    //  se doreste controlul calitatii semnaturii. Are forma:
    //sig1&sig2...sign|nrPagina|x|y|latime|inaltime
    //  unde sigi este numele posibil al unui AcroField in fisierul PDF
    //      unde se doreste plasata semnatura. Daca nu exista nici un camp
    //      cu nici unul din numele propuse se folosesc restul parametrilor,
    //      daca exista (numarul paginii (1, 2... primele pagini, -1 ultima,
    //      -2 penultima,...). Se admit 1,2 sau 6 parametri (separati de '|')
    public SuperIntegrator(String configPath, String tempPath,
        String signatureDefinition, CertificateChooser chooser)
    {
        _configPath = padPath(configPath);
        _tempPath = padPath(tempPath);
        if(tempPath == null)
        {
            _tempPath = _configPath;
        }
        _integrator = new Integrator();
        _integrator.setConfigPath(configPath);
        _integrator.setSignatureDefinition(signatureDefinition);
        if(chooser != null)
        {
            _integrator.setChooser(chooser);
        }
    }

    //functiile intorc:
    //-200 - eroare semnare PDF
    //-100 - eroare de creare PDF
    //-50 - eroare manipulare fisier intern
    //daca validarea fisierului esueaza pot aparea erorile:
    //-9 - exceptie neasteptata (nu ar trebui sa apara)
    //-8 - declaratie necunoscuta
    //-7 - exceptie InstantiationException sau IllegalAccessException (nu ar trebui sa apara)
    //-6 - exceptie ClassNotFoundException (nu ar trebui sa apara)
    //-5 - exceptie neasteptata (nu ar trebui sa apara)
    //-3 - validare cu erori tehnice
    //-2 - validare cu erori de structura
    //-1 - validare cu erori de business
    //0 - PDF prelucrat cu succes (V/P/S)
    //1 - PDF prelucrat cu succes (V/P/S), dar atentionari in _fisierEroriParsare
    public int parseDocument(String decl, String xmlFile,
        String errFile, long option)
    {
        _erori = null;
        _integrator.setDeclType(decl);
        _integrator.useOptions(option);
        return _integrator.parseDocument(xmlFile, errFile);
    }

    public int pdfCreation(String decl, String xmlFile,
        String errFile, long option,
        String zipFile, String pdfFile)
    {
        _erori = null;
        _integrator.setDeclType(decl);
        _integrator.useOptions(option);
        return _integrator.pdfCreation(xmlFile, errFile, zipFile, pdfFile);
    }

    public int signPdf(String decl, String xmlFile,
        String errFile, long option,
        String zipFile, String pdfFile,
        String pin, String smartCard, int chooserIndex)
    {
        _erori = null;
        _integrator.setDeclType(decl);
        _integrator.useOptions(option);
        _integrator.setChooserIndex(chooserIndex);
        int ret = _integrator.signPdf(xmlFile, errFile, zipFile, pdfFile,
            pin, smartCard);
        _integrator.releaseToken();
        return ret;
    }

    //Sterge fisierele de la prelucrarea anterioara
    //Apelata automat pt. setul de functii avand continutul fisierului
    //  de prelucrat in buffer, ca parametru.
    //In acest caz utilizatorul clasei o va apela numai dupa ultimul fisier
    //  prelucrat (cand nu mai urmeaza alta prelucrare)
    //Poate fi apelata din afara, daca se doreste
    public void stergeFisiereAnterioare()
    {
        if(_xmlFile != null)
        {
            (new File(_xmlFile)).delete();
        }
        String file = _integrator.getFisierEroriParsare();
        if(file != null)
        {
            (new File(file)).delete();
        }
        file = _integrator.getFisierLogErori();
        if(file != null)
        {
            (new File(file)).delete();
        }
        file = _integrator.getFisierTraceErori();
        if(file != null)
        {
            (new File(file)).delete();
        }
        file = _integrator.getFisierPdf();
        if(file != null)
        {
            (new File(file)).delete();
        }
    }

    //creaza un nume fisier aleatoriu in folderul _tempPath, cu extensia
    //  .pdf sau .xml, dupa caz, al carui nume se gaseste
    //  in variabile _xmlFile
    //copiaza continutul de la intrare in acest fisier
    //intoarce null daca OK sau textul erori (aflat si in variabila _erori)
    //  altfel
    private String storeBinaryFile(byte[] file)
    {
        _erori = null;
        _xmlFile = _tempPath + Long.toString(System.currentTimeMillis())
            + "_" + Long.toString(_random.nextLong()) + ".";
        if(file[0] == '%' && file[1] == 'P'
            && file[2] == 'D' && file[3] == 'F')
        {
            _xmlFile += "pdf";
        }
        else
        {
            _xmlFile += "xml";
        }
        FileOutputStream fo = null;
        try
        {
            fo = new FileOutputStream(_xmlFile);
            fo.write(file);
            fo.close();
        }
        catch(Throwable ex)
        {
            _erori = "eroare creare fisier '" + _xmlFile + "': " + ex.toString();
            return _erori;
        }
        return null;
    }

    public int parseDocument(String decl, byte[] xmlFile,
        String errFile, long option)
    {
        stergeFisiereAnterioare();
        if(storeBinaryFile(xmlFile) != null)
        {
            return -50;
        }
        return parseDocument(decl, _xmlFile, errFile, option);
    }

    public int pdfCreation(String decl, byte[] xmlFile,
        String errFile, long option,
        String zipFile, String pdfFile)
    {
        stergeFisiereAnterioare();
        if(storeBinaryFile(xmlFile) != null)
        {
            return -50;
        }
        return pdfCreation(decl, _xmlFile, errFile, option,
            zipFile, pdfFile);
    }

    public int signPdf(String decl, byte[] xmlFile,
        String errFile, long option,
        String zipFile, String pdfFile,
        String pin, String smartCard, int chooserIndex)
    {
        stergeFisiereAnterioare();
        if(storeBinaryFile(xmlFile) != null)
        {
            return -50;
        }
        int ret = signPdf(decl, xmlFile, errFile, option,
            zipFile, pdfFile, pin, smartCard, chooserIndex);
        return ret;
    }

    private static String padPath(String path)
    {
        if(path != null)
        {
            if(path.endsWith("/") == false && path.endsWith("\\") == false)
            {
                return path + File.separator;
            }
        }
        return path;
    }

    //intoarce continutul text al fisierului indicat
    //  sau null daca nu exista fisier sau daca sunt erori manipulare fisier
    //in ultimul caz eroarea se afla in _erori
    private String getTextFile(String fileName)
    {
        _erori = null;
        StringBuffer buff = new StringBuffer();
        String line = null;
        if(fileName == null)
        {
            return null;
        }
        try
        {
            BufferedReader file = new BufferedReader(new FileReader(fileName));
            do
            {
                line = file.readLine();
                if(line == null)
                {
                    break;
                }
                buff.append(line).append(_newLine);
            }
            while(true);
            file.close();
        }
        catch(Throwable ex)
        {
            _erori = "eroare citire fisier '" + fileName + "': " + ex.toString();
            return null;
        }
        return buff.toString();
    }

    //intoarce continutul binar al fisierului indicat
    //  sau null daca nu exista fisier sau daca sunt erori manipulare fisier
    //in ultimul caz eroarea se afla in _erori
    private byte[] getBinaryFile(String fileName)
    {
        _erori = null;
        byte[] content = null;
        if(fileName == null)
        {
            return null;
        }
        FileInputStream fi = null;
        File file = null;
        try
        {
            file = new File(fileName);
            fi = new FileInputStream(file);
            content = new byte[(int)file.length()];
            fi.read(content);
            fi.close();
        }
        catch(Throwable ex)
        {
            _erori = "eroare citire fisier '" + fileName + "': " + ex.toString();
            return null;
        }
        return content;
    }

    //intoarce:
    //1 - parsare xml/pdf (V)
    //2 - creare pdf (P)
    //3 - semnare pdf (S)
    public int getUltimTipOperatie()
    {
        return _integrator.getTipApel();
    }

    //-200 - eroare semnare PDF
    //-100 - eroare de creare PDF
    //-50 - eroare manipulare fisier intern
    //daca validarea fisierului esueaza pot aparea erorile:
    //-9 - exceptie neasteptata (nu ar trebui sa apara)
    //-8 - declaratie necunoscuta
    //-7 - exceptie InstantiationException sau IllegalAccessException (nu ar trebui sa apara)
    //-6 - exceptie ClassNotFoundException (nu ar trebui sa apara)
    //-5 - exceptie neasteptata (nu ar trebui sa apara)
    //-3 - validare cu erori tehnice
    //-2 - validare cu erori de structura
    //-1 - validare cu erori de business
    //0 - PDF prelucrat cu succes (V/P/S)
    //1 - PDF prelucrat cu succes (V/P/S), dar atentionari in _fisierEroriParsare
    public int getRaspunsPrelucrare()
    {
        return _integrator.getRaspunsPrelucrare();
    }

    //intoarce textul rezultat in urma prelucrarii in formatul afisat
    //  de DUKIntegrator
    public String getTextRaspuns()
    {
        String text = _integrator.getFinalMessage();
        if(_erori != null)
            text += _newLine + _erori;
        return text;
    }

    //intoarce numele fisierului de erori parsare, daca exista,
    //  sau null altfel
    public String getNumeFisierErori()
    {
        return _integrator.getFisierEroriParsare();
    }

    //intoarce continutul fisierului de erori parsare, daca exista,
    //  sau null altfel
    //consultati si _erori daca != null, pt posibile erori de manipulare fisiere
    public String getFisierErori()
    {
        return getTextFile(_integrator.getFisierEroriParsare());
    }

    //intoarce numele fisierului de log erori parsare, daca exista,
    //  sau null altfel
    public String getNumeFisierLog()
    {
        return _integrator.getFisierLogErori();
    }

    //intoarce continutul fisierului de log erori parsare, daca exista,
    //  sau null altfel
    //consultati si _erori daca != null, pt posibile erori de manipulare fisiere
    public String getFisierLog()
    {
        return getTextFile(_integrator.getFisierLogErori());
    }

    //intoarce numele fisierului de trace erori parsare, daca exista,
    //  sau null altfel
    public String getNumeFisierTrace()
    {
        return _integrator.getFisierTraceErori();
    }

    //intoarce continutul fisierului de trace erori parsare, daca exista,
    //  sau null altfel
    //consultati si _erori daca != null, pt posibile erori de manipulare fisiere
    public String getFisierTrace()
    {
        return getTextFile(_integrator.getFisierTraceErori());
    }

    //intoarce numele fisierului PDF rezultat, daca exista,
    //  sau null altfel
    public String getNumeFisierPdf()
    {
        return _integrator.getFisierPdf();
    }

    //intoarce continutul fisierului PDF rezultat, daca exista,
    //  sau null altfel
    //consultati si _erori daca != null, pt posibile erori de manipulare fisiere
    public byte[] getFisierPdf()
    {
        return getBinaryFile(_integrator.getFisierPdf());
    }
}
